#!/bin/bash

# Kate script interface to html tidy
# Version 1 - 13/10/03
# by David Ross http://www.rossy.co.uk
# modified by Christoph Cullmann for Kate 2.2 (KDE 3.2)

################
# Start Config #
################

# Specify any options you want to pass to tidy
tidyoptions="-iu --wrap 0 --doctype transitional"

# File to write errors to
errfile="/tmp/tidy.err"

# Do you want a prompt before showing errors
# If you don't have "xmessage" set to 0
errprompt=1

##############
# Start Code #
##############

# Get the active document number
doc=`dcop $1 KateDocumentManager activeDocumentNumber`

# Get the current html from kate
DATAIN=`dcop $1 EditInterface#$doc text`

# Run the html through tidy
DATAOUT=`echo $DATAIN | tidy $tidyoptions 2> $errfile`

# Only send back the tidied version if there is valid html
if [ `echo $DATAOUT|grep -c "DOCTYPE"` -gt 0 ];then
dcop $1 EditInterface#$doc setText "$DATAOUT"
fi

# Open a new document with the error code should errors arise
if [ `cat $errfile|grep -c "No warnings or errors were found"` -eq 0 ];then
if [ $errprompt -eq 1 ];then
xmessage -center -buttons "Yes:1,No:0" "Errors were found Do you want to 
see them?"
fi
if [ $? -eq 1 ] || [ $errprompt -eq 0 ];then
dcop kate KateDocumentManager openURL "$errfile" ""
fi
fi
